#pragma once
#include "linkedlistnode.h"

namespace Datastructures {
	template <typename T> 
	class LinkedList
	{
	public:
		LinkedList();
		LinkedList(T value);
		~LinkedList();
		void append(T value);
		bool insert(T value, int index);
		bool remove(int index);
		int count() const;

	private:
		std::shared_ptr<Nodes::LinkedListNode<T>> mHead;
		std::shared_ptr<Nodes::LinkedListNode<T>> mTail;
		int mCount;
	};

	//Generic Class constructor for the Linked List
	template <typename T>
	LinkedList<T>::LinkedList() {
		mCount = 0;
		mHead = nullptr;
		mTail = nullptr;
	}

	//Class constructor for the Linked List, taking a preset value to go into the head of the list
	template <typename T>
	LinkedList<T>::LinkedList(T value) {
		mCount = 1;
		mHead = std::make_shared<Nodes::LinkedListNode<T>>(value);
		mTail = mHead;
	}


}